Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OracleClient
Imports BCb2b.Enterlan
Imports System.Configuration
Imports System.Globalization
Imports System.Web
Imports System.Net.Mail
Imports System.Collections.Generic
Imports System.Collections
Imports System.IO
Imports CTI.Utilities.MD5
Imports CTI.Utilities.Log
Imports System.Diagnostics

Partial Class _0pedido_lineas_por_confirmar
    Inherits ClaseBase

    Private GRUPO As String
    Private EMPRESA As String
    Private TIPVC As String
    Private TIPO_PED_SEL As String
    Private N_PEDIDO_SEL As String

    'Private GGESTADO_COD As String
    'Private HIST_SN As String

    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property

    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property

    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property

    Public ReadOnly Property PROP_TIPO_PED_SEL() As String
        Get
            Return Me.TIPO_PED_SEL
        End Get
    End Property

    Public ReadOnly Property PROP_N_PEDIDO_SEL() As String
        Get
            Return Me.N_PEDIDO_SEL
        End Get
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Not Page.IsPostBack Then

            If (Not Session("usuario") Is Nothing) Then

                Try
                    Me.Form.DefaultButton = Me.btnModificar.UniqueID
                Catch ex As Exception 'IIG

                End Try

                Try
                    lblProveedor.Text = Session("usuario").prop_nombre

                    lblPortes.Text = Session("usuario").prop_portes_pd_traduc
                    lblRsocial.Text = Session("usuario").prop_rsocial_cod

                    Dim menvio As New BCb2b.CGGMenvio(Session("usuario").prop_GGMENVIO_COD, Session("idioma_spyro"), "")
                    lblAgencia.Text = menvio.PROP_descrip
                    'lblAgencia.Text = Session("usuario").prop_GGMENVIO_DESC

                    HFCodProveedor.Value = Session("usuario").prop_COD

                    Me.EMPRESA = Session("empresa").prop_cod
                    Me.GRUPO = ConfigurationManager.AppSettings("grupo")
                    Me.TIPVC = ConfigurationManager.AppSettings("compra")

                    GestionBadges()

                    CargarLineasEnGrid()

                    VisibilidadBtnConfirmar()

                Catch ex As Exception 'IIG :) 2015/12/21
                    lblError.Text = GetLocalResourceObject("errorCargarDatos").ToString()
                    divError.Visible = True
                    btnModificar.Enabled = False
                    btnPrint.Enabled = False
                    Log.Warning(ex, "Error al cargar los datos")
                    'TraceHelper.WriteLine("ERROR: ", ex)
                End Try
            Else
                ResponseHelper.RedirectLogin(Page)
            End If

            btnPrint.Attributes.Add("onClick", "javascript:window.print();")
        End If
    End Sub

    Protected Sub btnModificar_Click(sender As Object, e As EventArgs) Handles btnModificar.Click
        Try
            If (Not Session("usuario") Is Nothing) Then
                divError.Visible = False

                Dim algunaLineaConfirmada As Boolean = False
                Dim Mensaje As String = String.Empty
                Dim lineasPedidoConfirmadas As New List(Of LineaPedidoConfirmada)

                lineasPedidoConfirmadas = ObtenerDatosGrid(algunaLineaConfirmada, Mensaje)

                If (ValidacionIncorrecta(Mensaje)) Then
                    MostrarMensaje(Mensaje)
                ElseIf (Not algunaLineaConfirmada) Then
                    MostrarMensaje(GetLocalResourceObject("ningunaLineaSeleccionada"))
                Else
                    GestionarGuardadoLineas(lineasPedidoConfirmadas)
                End If
            Else
                RedirectLogin(Page)
            End If
        Catch ex As Exception 'IIG :) 2015/12/21
            lblError.Text = GetLocalResourceObject("errorConfirmarLineas")
            divError.Visible = True
            Log.Error(ex, "Error al confirmar fechas")
            'TraceHelper.WriteLine("ERROR: ", ex)
        End Try
        GestionBadges()
    End Sub

    Public Function ObtenerDatosGrid(ByRef algunaLineaConfirmada As Boolean, ByRef mensaje As String) As List(Of LineaPedidoConfirmada)
        Dim CurrentCheckBox As CheckBox
        Dim CurrentFechaPrevista As TextBox
        Dim FechaPrevistaOriginal As TextBox
        Dim Empresa As TextBox
        Dim Grupo As TextBox
        Dim Tip_vc As TextBox
        Dim Ggpedtip_cod As TextBox
        Dim N_pedido As TextBox
        Dim N_lin As TextBox
        Dim FechaConfirmada As TextBox
        Dim LineaConfirmada As TextBox
        Dim CodArticulo As TextBox
        Dim DescArticulo As TextBox

        Dim i As Integer

        Dim lineasPedidoConfirmadas As New List(Of LineaPedidoConfirmada)

        For i = 0 To RDP.Items.Count - 1
            CurrentCheckBox = RDP.Items(i).FindControl("cboxSelec")
            If (CurrentCheckBox.Enabled And CurrentCheckBox.Checked) Then
                algunaLineaConfirmada = True

                CurrentFechaPrevista = RDP.Items(i).FindControl("F_ENTRPREV")

                If (String.IsNullOrEmpty(CurrentFechaPrevista.Text)) Then
                    mensaje = GetLocalResourceObject("fechaPrevistaVacia") '"No se pueden confirmar lneas de pedido con Fecha Entrega Prevista vaca."
                    Exit For
                End If

                If (Convert.ToDateTime(CurrentFechaPrevista.Text) < DateTime.Now.Date) Then
                    mensaje = GetLocalResourceObject("fechaPrevistaMenor")
                    Exit For
                End If

                'If (Convert.ToDateTime(FechaPrevistaOriginal) <> Convert.ToDateTime(CurrentFechaPrevista)) Then
                Dim lineaPedido As New LineaPedidoConfirmada()

                FechaPrevistaOriginal = RDP.Items(i).FindControl("tboxFechaEntrePrevOriginal")
                Empresa = RDP.Items(i).FindControl("empresa")
                Grupo = RDP.Items(i).FindControl("grupo")
                Tip_vc = RDP.Items(i).FindControl("tip_vc")
                Ggpedtip_cod = RDP.Items(i).FindControl("ggpedtip_cod")
                N_pedido = RDP.Items(i).FindControl("n_pedido")
                N_lin = RDP.Items(i).FindControl("n_lin")
                FechaConfirmada = RDP.Items(i).FindControl("fechaEntreConfirm")
                LineaConfirmada = RDP.Items(i).FindControl("lineaConfirmadaSN")
                CodArticulo = RDP.Items(i).FindControl("gaart_cod")
                DescArticulo = RDP.Items(i).FindControl("Descrip")

                lineaPedido.prop_empresa = Empresa.Text
                lineaPedido.prop_grupo = Grupo.Text
                lineaPedido.prop_tipVc = Tip_vc.Text
                lineaPedido.prop_tipoPedido = Ggpedtip_cod.Text
                lineaPedido.prop_pedido = N_pedido.Text
                lineaPedido.prop_lineaPedido = N_lin.Text
                lineaPedido.prop_fechaPrevista = CurrentFechaPrevista.Text
                lineaPedido.prop_fechaPrevistaOriginal = FechaPrevistaOriginal.Text
                lineaPedido.prop_fechaConfirmada = FechaConfirmada.Text
                lineaPedido.prop_lineaConfirmadaSN = LineaConfirmada.Text
                lineaPedido.prop_lineaConfirmadaSN = LineaConfirmada.Text
                lineaPedido.prop_lineaConfirmadaSN = LineaConfirmada.Text
                lineaPedido.prop_codArticulo = CodArticulo.Text
                lineaPedido.prop_descArticulo = DescArticulo.Text
                lineasPedidoConfirmadas.Add(lineaPedido)
                'End If
            End If
        Next

        Return lineasPedidoConfirmadas
    End Function

    Protected Sub RDP_ItemDataBound(sender As Object, e As RepeaterItemEventArgs) Handles RDP.ItemDataBound

        If (e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem) Then

            Dim numLinTextBox As TextBox = e.Item.FindControl("n_lin")
            Dim numPedTextBox As TextBox = e.Item.FindControl("n_pedido")
            Dim tipoPedTextBox As TextBox = e.Item.FindControl("ggpedtip_cod")
            Dim fechaConfTextBox As TextBox = e.Item.FindControl("fechaEntreConfirm")
            Dim lineaConfTextBox As TextBox = e.Item.FindControl("lineaConfirmadaSN")

            Dim colorEstado As String = LineaPedido.ObtenerColorEstado(lineaConfTextBox.Text, fechaConfTextBox.Text)
            Dim divEstado As HtmlGenericControl = e.Item.FindControl("divEstado")
            divEstado.Attributes.Add("class", String.Format("icono-estado {0}", colorEstado))

            Dim miCheck As CheckBox = e.Item.FindControl("cboxSelec")
            Dim miTExtbox As TextBox = e.Item.FindControl("F_ENTRPREV")

            'Dim miRFV As RequiredFieldValidator = e.Item.FindControl("tboxC_uni1rfv")
            'Dim miRV As CompareValidator = e.Item.FindControl("tboxC_uni1rVv")

            miTExtbox.Attributes.Add("onchange", "activarLinea('" + miCheck.ClientID + "');") ','" + miTExtbox.ClientID + "','" + miRFV.ClientID + "','" + miRV.ClientID + "');")
            miCheck.Attributes.Add("onclick", "activarLineaCheck('" + miCheck.ClientID + "','" + miTExtbox.ClientID + "');") ','" + miRFV.ClientID + "','" + miRV.ClientID + "');")

            'If (LineaConfirmada(numLinTextBox.Text)) Then
            '    miCheck.Enabled = False
            'End If

        End If

    End Sub

    Protected Sub RDP_ItemCommand(sender As Object, e As RepeaterCommandEventArgs) Handles RDP.ItemCommand
        If (e.CommandName = "verPedido") Then
            If (e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem) Then

                Dim numPedTextBox As TextBox = e.Item.FindControl("n_pedido")
                Dim tipoPedTextBox As TextBox = e.Item.FindControl("ggpedtip_cod")
                Dim grupoTextBox As TextBox = e.Item.FindControl("grupo")
                Dim empresaTextBox As TextBox = e.Item.FindControl("empresa")
                Dim tipvcTextBox As TextBox = e.Item.FindControl("tip_vc")

                Me.N_PEDIDO_SEL = numPedTextBox.Text
                Me.TIPO_PED_SEL = tipoPedTextBox.Text
                Me.GRUPO = grupoTextBox.Text
                Me.EMPRESA = empresaTextBox.Text
                Me.TIPVC = tipvcTextBox.Text


                Server.Transfer("0pedido_detalle_confirmacion.aspx")
            End If
        End If
    End Sub

    Public Sub EnviarMail(lineasModificadas As List(Of LineaPedidoConfirmada), nombreCliente As String)

        Dim parametro As New BCb2b.CParametros()
        'Dim host As String = parametro.dame_param("SPYRO_IP_SERVIDOR_EMAIL")

        Dim para As String = parametro.dame_param("B2B_DEST_MAIL_CONF_ORDER_PROV")

        Dim titulo As String = String.Format("Confirmacin lneas F. Entrega cambiada en Pedidos del Proveedor: {0}", nombreCliente)

        Dim CUERPO As String = ""

        CUERPO = "<html><head>"

        CUERPO = CUERPO & "<style>body {font-family: 'Open Sans',Arial,Helvetica,sans-serif; color: #000000;font-size: 12px;}" & _
            ".tablas_nuevas th, .table th, #container2 table th, .tabla_chiqui th, .tablas_nuevas_sin_altern th, .div_tablas_nuevas table th {" & _
               "padding: 6px 4px;" & _
            "margin: 0px;" & _
            "text-align: center;" & _
            "font-size: 12px;" & _
            "color: #FFF !important;" & _
            "text-shadow: 0px 0px 0px #000;" & _
            "border-left: 1px solid #FFF;" & _
            "font-weight: normal;" & _
            "background: #0081C6 none repeat scroll 0% 0%;" & _
        "}" & _
        ".table { font-size: 12px; }" & _
        ".table tr.colorfondo td {" & _
            "background: #E5EDF5 none repeat scroll 0% 0%;" & _
        "}" & _
        ".table td {" & _
            "background: #FFF none repeat scroll 0% 0%;" & _
            "padding: 6px;" & _
            "margin: 0px;" & _
            "color: #000000;" & _
            "font-size: 12px !important;" & _
            "border: medium none;" & _
        "}" & _
        ".left2 {" & _
        "    text-align: right;" & _
        "    padding-right: 0.5em;" & _
        "    background-color: #F8F8F8;" & _
        "    width: 24%;" & _
        "    font-size: 12px !important;" & _
        "    color: #000000;" & _
        "    text-transform: uppercase;" & _
        "}" & _
        ".right {" & _
        "    text-align: left;" & _
        "    padding-left: 0.4em;" & _
        "    background-color: #F1F1F1;" & _
        "    font-size: 12px !important;" & _
        "    font-weight: normal;" & _
        "}" & _
        ".BORDE {" & _
            "border: 1px solid #CCC;" & _
        "}" & _
        ".upper, .to_upper th {" & _
            "text-transform: uppercase !important;" & _
        "}" & _
        ".rojo {" & _
            "background-color: #ED1C24 !important;" & _
        "}" & _
        ".verde {" & _
            "background-color: #B5E61D !important;" & _
        "}" & _
        ".negro {" & _
            "background-color: #000000 !important; color:#ffffff;" & _
        "}" & _
        ".blanco {" & _
            "background-color: #ffffff !important;" & _
        "}" & _
        "</style></head><body>"

        CUERPO = CUERPO & String.Format("<p>El Proveedor <strong>{0}</strong> ha modificado las siguientes lneas:</p><br />", nombreCliente)

        Dim currentPed As String = ""
        lineasModificadas.Sort()
        'Dim result = From p In lineasModificadas Order By p.prop_pedido
        For Each lineaModificada As LineaPedidoConfirmada In lineasModificadas
            If (lineaModificada.prop_pedido <> currentPed) Then
                CUERPO = CUERPO & String.Format("<p>Pedido: <strong>{0}</strong></p>", lineaModificada.prop_pedido)

                currentPed = lineaModificada.prop_pedido
            End If
            CUERPO = CUERPO & String.Format("<ul>")
            CUERPO = CUERPO & String.Format("<li>Lnea: <strong>{0}</strong>   Artculo: <strong>{1} - {2}</strong><ul><li>F. Entrega Requerida por AMC: <strong>{3}</strong></li><li>F. Entrega Prevista Modificada por {4}: <strong>{5}</strong></li></ul></li>" _
                                            , lineaModificada.prop_lineaPedido, lineaModificada.prop_codArticulo, lineaModificada.prop_descArticulo, lineaModificada.prop_fechaPrevistaOriginal, nombreCliente, lineaModificada.prop_fechaPrevista)
            CUERPO = CUERPO & String.Format("</ul>")
        Next

        CUERPO = CUERPO & "</body></html>"

        Dim mailing As New BCb2b.EnviarMail()
        Try
            Dim enviado As String = ""

            enviado = mailing.SendMail_NET(ConfigurationManager.AppSettings("EmailFrom"), ConfigurationManager.AppSettings("EmailFrom"), para, titulo, CUERPO, "")

            If (enviado = 1) Then
                Log.Warning("No se ha podido enviar el mail de confirmacin para el pedido")
                'TraceHelper.WriteLine("No se ha podido enviar el mail de confirmacin para el pedido ")
            End If

        Catch ex As Exception 'IIG :) 2015/12/21
            Log.Warning(ex, "No se ha podido enviar el mail de confirmacin para el pedido")
            'TraceHelper.WriteLine("Error al enviar el mail de confirmacin para el pedido ", ex)
        End Try
    End Sub

    Private Function ValidacionIncorrecta(mensaje As String) As Boolean
        Return Not String.IsNullOrEmpty(mensaje)
    End Function

    Private Sub MostrarMensaje(mensaje As String)
        lblerror.Text = mensaje
        divError.Visible = True
    End Sub

    Private Function ErrorAlGuardar(mensaje As String) As Boolean
        Return Not String.IsNullOrEmpty(mensaje)
    End Function

    Private Sub CargarLineasEnGrid()
        Dim paramSeries As String = ConfigurationManager.AppSettings("PARAM_SERIES_PEDIDO")

        Dim lineas As New BCb2b.CLineaPedido()

        Dim listaLineas As ArrayList = lineas.lista_lineas_confirmacion_retrasos(Me.PROP_GRUPO, Me.PROP_EMPRESA, Me.PROP_TIPVC, HFCodProveedor.Value, ObtenerOpcionSeleccionada(), paramSeries, tboxNPedido.Text, tboxFDesde.Text, tboxFHasta.Text)
        RDP.DataSource = listaLineas

        RDP.DataBind()

        If (listaLineas.Capacity <= 0) Then
            divNoHayLineas.Visible = "true"

            cabecera_lineasPed.Visible = False
            btnModificar.Visible = False
        Else
            divNoHayLineas.Visible = "false"
            cabecera_lineasPed.Visible = True
            btnModificar.Visible = True
        End If
    End Sub

    Private Function ObtenerOpcionSeleccionada() As String
        If (rbtnSinConfirmar.Checked) Then
            Return BCb2b.CLineaPedido.SIN_CONFIRMAR
        ElseIf (rbtnConfirmado.Checked) Then
            Return BCb2b.CLineaPedido.CONFIRMADO
        ElseIf (rbtnSinConfirmarRetrasado.Checked) Then
            Return BCb2b.CLineaPedido.SIN_CONFIRMAR_RETRASADO
        ElseIf (rbtnConfirmadoRetrasado.Checked) Then
            Return BCb2b.CLineaPedido.CONFIRMADO_RETRASADO
        End If
        Return ""
    End Function

    Private Function GuardarLineasConfirmadas(lineasPedidoConfirmadas As List(Of LineaPedidoConfirmada), ByRef falloConfirmAlgunaLinea As Boolean) As List(Of LineaPedidoConfirmada)
        Dim errorMessage As String

        Dim lineasFechaModificada As New List(Of LineaPedidoConfirmada)
        For Each linea As LineaPedidoConfirmada In lineasPedidoConfirmadas
            'Guardar la linea
            Dim lineaPedido As New BCb2b.CLineaPedido()

            Dim conexion As String = GenerarStringConexion(Page)
            TraceHelper.WriteLine("Conexion: " & conexion)
            errorMessage = lineaPedido.ConfirmarFechasLinea(linea.prop_grupo, linea.prop_empresa, linea.prop_tipVc, linea.prop_tipoPedido, linea.prop_pedido, linea.prop_lineaPedido, linea.prop_fechaPrevista, linea.prop_fechaPrevista, conexion) ' IIG - 2015\07\23 :) Ponemos la fecha confirmada igual que la prevista porque sino puede ser que la primera sea mayor que la segunda y da un error

            If (Not ErrorAlGuardar(errorMessage) And Convert.ToDateTime(linea.prop_fechaPrevistaOriginal) <> Convert.ToDateTime(linea.prop_fechaPrevista)) Then
                lineasFechaModificada.Add(linea)
            End If

            If (ErrorAlGuardar(errorMessage)) Then
                TraceHelper.WriteLine(String.Format("Error al guardar linea {0} del pedido {1}  ERROR: {2}", linea.prop_lineaPedido, Me.N_PEDIDO_SEL, errorMessage))
                falloConfirmAlgunaLinea = True
            End If
        Next

        Return lineasFechaModificada
    End Function

    Private Sub GestionarGuardadoLineas(lineasPedidoConfirmadas As List(Of LineaPedidoConfirmada))

        Me.GRUPO = lineasPedidoConfirmadas(0).prop_grupo
        Me.EMPRESA = lineasPedidoConfirmadas(0).prop_empresa
        Me.TIPVC = lineasPedidoConfirmadas(0).prop_tipVc
        Me.TIPO_PED_SEL = lineasPedidoConfirmadas(0).prop_tipoPedido
        Me.N_PEDIDO_SEL = lineasPedidoConfirmadas(0).prop_pedido

        Dim falloConfirmAlgunaLinea As Boolean = False
        Dim lineasFechaModificada As New List(Of LineaPedidoConfirmada)

        lineasFechaModificada = GuardarLineasConfirmadas(lineasPedidoConfirmadas, falloConfirmAlgunaLinea)

        If (lineasFechaModificada.Count() > 0) Then
            'Enviar mail a quien corresponda avisando
            EnviarMail(lineasFechaModificada, lblProveedor.Text)
        End If

        If (falloConfirmAlgunaLinea) Then
            MostrarMensaje(GetLocalResourceObject("algunaLineaNoConfirmada"))
        End If

        CargarLineasEnGrid()

    End Sub

    Protected Sub btnBuscar_Click(sender As Object, e As EventArgs) Handles btnBuscar.Click
        divError.Visible = False

        Me.EMPRESA = ConfigurationManager.AppSettings("empresa")
        Me.GRUPO = ConfigurationManager.AppSettings("grupo")
        Me.TIPVC = ConfigurationManager.AppSettings("compra")

        CargarLineasEnGrid()

        VisibilidadBtnConfirmar()
    End Sub

    'Protected Function LineaConfirmada(tipoPedido As String, numPedido As String, ByVal numLinea As String) As Boolean
    '    Return LineaPedido.LineaConfirmada(tipoPedido, numPedido, numLinea)
    'End Function

    Private Sub VisibilidadBtnConfirmar()
        If (rbtnConfirmado.Checked Or rbtnConfirmadoRetrasado.Checked) Then
            btnModificar.Visible = False
        End If
    End Sub

    Private Sub GestionBadges()
        GestionBadge(lblBadgeSinConf, BCb2b.CLineaPedido.SIN_CONFIRMAR)
        GestionBadge(lblBadgeConf, BCb2b.CLineaPedido.CONFIRMADO)
        GestionBadge(lblBadgeSinConfRet, BCb2b.CLineaPedido.SIN_CONFIRMAR_RETRASADO)
        GestionBadge(lblBadgeConfRet, BCb2b.CLineaPedido.CONFIRMADO_RETRASADO)
    End Sub

    Private Sub GestionBadge(label As WebControls.Label, estado As String)
        Dim paramSeries As String = ConfigurationManager.AppSettings("PARAM_SERIES_PEDIDO")
        Dim lineasPed As New BCb2b.CLineaPedido()

        'JCE. 22/07/16. AL HACER POSTBACK SE PERDIAN ESTOS VALORES Y NO MOSTRABA LOS BADGES.
        Me.GRUPO = ConfigurationManager.AppSettings("grupo")
        Me.EMPRESA = ConfigurationManager.AppSettings("empresa")
        Me.TIPVC = ConfigurationManager.AppSettings("compra")

        Dim lineas As Integer = lineasPed.lista_lineas_confirmacion_retrasos(Me.GRUPO, Me.EMPRESA, Me.TIPVC, HFCodProveedor.Value, estado, paramSeries).Count()
        If (lineas > 0) Then
            label.Visible = True
            label.Text = lineas
        Else
            label.Visible = False
            label.Text = ""
        End If
    End Sub

End Class
